/*-------------------------------------------------------------------------
                       B r u k e r
                      
    An environment control driver and an additonal wrapper function for
    controlling a Bruker B-EC-1 magnet controller. This controller can 
    either control a current or control the current through an external hall 
    sensor mesuring the magnetic field. In both cases both values: the field 
    and the current must be readable.
    
    copyright: see copyright.h
    
    Mark Koennecke, October 1998                   
---------------------------------------------------------------------------*/
#ifndef BRUKERMAGNET
#define BRUKERMAGNET

pEVDriver CreateBrukerDriver(int argc, char *argv[]);

int BrukerReadField(pEVControl self, float *fField);
int BrukerReadCurrent(pEVControl self, float *fCurrent);

int BrukerAction(SConnection * pCon, SicsInterp * pSics, void *pData,
                 int argc, char *argv[]);

#endif
